<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../paper-input/paper-textarea.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">

<dom-module id="dez-label-bar-edit-tags-list">
  <template>
    <style>
    </style>
    <paper-icon-button icon="create" title="edit labels" on-tap="_openEditButtonsDialog"></paper-icon-button>
    <paper-dialog id="editButtonsDialog" entry-animation="fade-in-animation" exit-animation="fade-out-animation" with-backdrop>
      <h2><iron-icon icon="create"></iron-icon> &nbsp; Étiquettes</h2>
      <paper-textarea label="" value="{{_taValues}}" rows="9" max-rows="9"></paper-textarea>
      <p>
        Indiquez une étiquette par ligne.
        Chaque étiquette est associée à un bouton.
      </p>
      <div class="buttons">
        <paper-button dialog-dismiss>Annuler</paper-button>
        <paper-button dialog-confirm autofocus  on-tap="_changeTags">OK</paper-button>
      </div>
    </paper-dialog>
  </template>

  <script>
    class DezLabelBarEditTagsList extends Polymer.Element {

      static get is() { return 'dez-label-bar-edit-tags-list'; }

      static get properties() {
        return {
          tags: {
            type: Array,
            notify: true,
            observer: "_tagsChanged"
          }
        };
      }

      _openEditButtonsDialog () {
          this.$.editButtonsDialog.open();
      }

      _changeTags (event) {
        this.tags = this._taValues.split("\n").filter(type => type != "")
      }

      _tagsChanged () {
        this._taValues = this.tags.reduce((string, type) => string + type + "\n", "")
      }

    }

    window.customElements.define(DezLabelBarEditTagsList.is, DezLabelBarEditTagsList);
  </script>
</dom-module>
